$regfile = "m8adef.dat"
$crystal = 8000000
$hwstack = 32
$swstack = 16
$framesize = 32
$baud = 57600

$version 1 , 0 , 62


'********************  Timer 1 0,1s  ********************
'-------------------------------------------------------------------------------
Const Timer1reload = 3125
Config Timer1 = Timer , Prescale = 256
Load Timer1 , Timer1reload
On Ovf1 Timer1_isr
Enable Timer1
Start Timer1

'********************  UART  ********************
'-------------------------------------------------------------------------------
Config Serialin = Buffered , Size = 50 , Bytematch = 10
Enable Serial


'********************  IO Config  ********************
'-------------------------------------------------------------------------------
Config Debounce = 100

Const C_Tmr_off_1 = 400
Const C_Tmr_off_2 = 280
Const C_tmr_double_1 = 396
Const C_tmr_double_2 = 276
Const C_tmr_man = 30

Out_1 Alias Portc.1 : Config Out_1 = Output
Out_2 Alias Portc.0 : Config Out_2 = Output
Out_3 Alias Portb.2 : Config Out_3 = Output
Out_4 Alias Portb.1 : Config Out_4 = Output

Led_1 Alias Portb.7 : Config Led_1 = Output
Led_2 Alias Portb.6 : Config Led_2 = Output
Led_c Alias Portc.4 : Config Led_c = Output

In_1 Alias Pinb.0 : Config In_1 = Input
In_2 Alias Pind.7 : Config In_2 = Input
In_3 Alias Pind.6 : Config In_3 = Input
In_4 Alias Pind.5 : Config In_4 = Input

'********************  Variable Config  ********************
'-------------------------------------------------------------------------------
Dim Uart_rx_ok As Bit
Dim Mode_aut_1 As Bit , Mode_aut_2 As Bit

Dim I As Byte , Ir As Byte
Dim Tmr_off_1 As Word , Tmr_man_1 As Byte
Dim Tmr_off_2 As Word , Tmr_man_2 As Byte

Dim Uart_len As Byte , Ui As Byte , Uart_arr(51) As Byte
Dim Uart_str As String * 50 At Uart_arr() Overlay

Reset Out_1 : Reset Out_2 : Reset Out_3 : Reset Out_4
Reset Led_1 : Reset Led_2

Mode_aut_1 = 1 : Mode_aut_2 = 1


Enable Interrupts

'********************  M A I N  ********************
'-------------------------------------------------------------------------------
Do

   Debounce In_1 , 1 , On_t1 , Sub
   Debounce In_2 , 1 , On_t2 , Sub
   Debounce In_3 , 1 , On_t3 , Sub
   Debounce In_4 , 1 , On_t4 , Sub

'Booatloader
'-------------------------------------------------------------------------------
   If _rs232inbuf0(_rs_bufcountr0 - 1) = 123 And _rs232inbuf0(_rs_bufcountr0 - 2) = 123 And _rs232inbuf0(_rs_bufcountr0 - 3) = 123 Then Goto &H0C00

   If Mode_aut_1 = 0 Then
      Waitms 100
      If In_1 <> In_2 Then
         If In_1 = 1 Then
            If Out_2 = 1 Then
               Out_2 = 0
               Waitms 250
            End If
            Set Out_1
         End If

         If In_2 = 1 Then
            If Out_1 = 1 Then
               Out_1 = 0
               Waitms 250
            End If
            Set Out_2
         End If

      Elseif In_1 = 0 And In_2 = 0 Then
         Reset Out_1
         Reset Out_2
      End If
   End If

   If Mode_aut_2 = 0 Then
      Waitms 100
      If In_3 <> In_4 Then
         If In_3 = 1 Then
            If Out_4 = 1 Then
               Out_4 = 0
               Waitms 250
            End If
            Set Out_3
         End If

         If In_4 = 1 Then
            If Out_3 = 1 Then
               Out_3 = 0
               Waitms 250
            End If
            Set Out_4
         End If

      Elseif In_3 = 0 And In_4 = 0 Then
         Reset Out_3
         Reset Out_4
      End If
   End If


Loop



'******************************  Tipka 1  ******************************
'-------------------------------------------------------------------------------
On_t1:

   If Out_2 = 1 Then : Reset Out_2 : Waitms 250 : End If

   If Mode_aut_1 = 1 Then
      If Tmr_off_1 = 0 Then
         Set Out_1
         Tmr_off_1 = C_Tmr_off_1
      Elseif Tmr_man_1 = 0 And Tmr_off_1 < C_tmr_off_1 And Tmr_off_1 > C_tmr_double_1 Then
         Tmr_man_1 = C_Tmr_man
         Mode_aut_1 = 0
      Else
         Reset Out_1 : Reset Out_2
         Reset Led_1
         Tmr_off_1 = 0
         Tmr_man_1 = 0
      End If
   Else
      Tmr_man_1 = C_Tmr_man
      Tmr_off_1 = C_Tmr_off_1
   End If

Return


'******************************  Tipka 2  ******************************
'-------------------------------------------------------------------------------
On_t2:

   If Out_1 = 1 Then : Reset Out_1 : Waitms 250 : End If

   If Mode_aut_1 = 1 Then
      If Tmr_off_1 = 0 Then
         Set Out_2
         Tmr_off_1 = C_Tmr_off_1
      Elseif Tmr_man_1 = 0 And Tmr_off_1 < C_tmr_off_1 And Tmr_off_1 > C_tmr_double_1 Then
         Tmr_man_1 = C_Tmr_man
         Mode_aut_1 = 0
      Else
         Reset Out_1 : Reset Out_2
         Reset Led_1
         Tmr_off_1 = 0
         Tmr_man_1 = 0
      End If
   Else
      Tmr_man_1 = C_tmr_man
      Tmr_off_1 = C_Tmr_off_1
   End If


Return


'******************************  Tipka 3  ******************************
'-------------------------------------------------------------------------------
On_t3:

   If Out_4 = 1 Then : Reset Out_4 : Waitms 250 : End If

   If Mode_aut_2 = 1 Then
      If Tmr_off_2 = 0 Then
         Set Out_3
         Tmr_off_2 = C_tmr_off_2
      Elseif Tmr_man_2 = 0 And Tmr_off_2 < C_tmr_off_2 And Tmr_off_2 > C_tmr_double_2 Then
         Tmr_man_2 = C_tmr_man
         Mode_aut_2 = 0
      Else
         Reset Out_3 : Reset Out_4
         Reset Led_2
         Tmr_off_2 = 0
         Tmr_man_2 = 0
      End If
   Else
      Tmr_man_2 = C_tmr_man
      Tmr_off_2 = C_tmr_off_2
   End If

Return


'******************************  Tipka 4  ******************************
'-------------------------------------------------------------------------------
On_t4:

   If Out_4 = 1 Then : Reset Out_4 : Waitms 250 : End If

   If Mode_aut_2 = 1 Then
      If Tmr_off_2 = 0 Then
         Set Out_4
         Tmr_off_2 = C_tmr_off_2
      Elseif Tmr_man_2 = 0 And Tmr_off_2 < C_tmr_off_2 And Tmr_off_2 > C_tmr_double_2 Then
         Tmr_man_2 = C_tmr_man
         Mode_aut_2 = 0
      Else
         Reset Out_3 : Reset Out_4
         Reset Led_2
         Tmr_off_2 = 0
         Tmr_man_2 = 0
      End If
   Else
      Tmr_man_2 = C_tmr_man
      Tmr_off_2 = C_tmr_off_2
   End If

Return

'********************  Timer1 ISR  ********************
'-------------------------------------------------------------------------------
Timer1_isr:

   Load Timer1 , Timer1reload

   If Tmr_off_1 > 0 Then
      Decr Tmr_off_1
      I = Tmr_off_1 Mod 5
      If I = 0 Then Toggle Led_1
      If Tmr_off_1 = 0 Then
         Reset Out_1 : Reset Out_2
         Reset Led_1
      End If
   End If

   If Tmr_man_1 > 0 Then
      Decr Tmr_man_1
      Set Led_1
      If Tmr_man_1 = 0 Then
         Mode_aut_1 = 1
         Reset Led_1
         If In_1 = 0 And In_2 = 0 Then Tmr_off_1 = 0
      End If
   End If

   If Tmr_off_2 > 0 Then
      Decr Tmr_off_2
      I = Tmr_off_2 Mod 5
      If I = 0 Then Toggle Led_2
      If Tmr_off_2 = 0 Then
         Reset Out_3 : Reset Out_4
         Reset Led_2
      End If
   End If

   If Tmr_man_2 > 0 Then
      Decr Tmr_man_2
      Set Led_2
      If Tmr_man_2 = 0 Then
         Mode_aut_2 = 1
         Reset Led_2
         If In_3 = 0 And In_4 = 0 Then Tmr_off_2 = 0
      End If
   End If

   If Led_c = 1 Then Led_c = 0

Return


'********************  UART ISR  ********************
'-------------------------------------------------------------------------------
Serial0charmatch:


   Disable Interrupts
   Pushall

   If _rs232inbuf0(_rs_bufcountr0 - 1) = 13 Then

      Uart_len = _rs_bufcountr0 - 2
      For Ir = 1 To Uart_len                                'Input Uart1_str , Noecho
         Uart_arr(ir) = _rs232inbuf0(ir)
      Next
      Uart_rx_ok = 1
      Clear Serialin

      Set Led_c

   End If

   Popall
   Enable Interrupts

Return