$regfile = "m168pdef.dat"
$crystal = 11059200
$hwstack = 40
$swstack = 16
$framesize = 32
$baud = 9600
$version 0 , 1 , 58

Config Portc.0 = Output : Led_g Alias Portc.0
Config Portc.1 = Output : Led_r Alias Portc.1
Config Portc.2 = Output : Led_b Alias Portc.2

Config Portd.2 = Output : Rf_cfg Alias Portd.2
Config Portd.3 = Output : Rf_en Alias Portd.3


'OC0a = pwm output za zvezni izhod
Config Timer0 = Pwm , Pwm = On , Compare_a_pwm = Clear_up , Prescale = 64       ' , Clear_timer = 1
Pwm0a = 127                                                 '5V = ventilator stoji; 0=0V, 255=10V
Config Portd.6 = Output                                     'PWM OC0A

Const Timer1reload = 43200                                  '1s timer
Config Timer1 = Timer , Prescale = 256
Load Timer1 , Timer1reload
On Ovf1 Timer1_1s
Enable Timer1
Start Timer1

Config Com1 = Dummy , Synchrone = 0 , Parity = None , Stopbits = 1 , Databits = 8 , Clockpol = 0
Config Serialin = Buffered , Size = 200 , Bytematch = 27

Config Adc = Single , Prescaler = Auto , Reference = Internal
'-------------------------------------------------------------------------------

'SHT VARIABLES
Const Sht31write = &B10001000                               'Sensor address witn write bit=0
Const Sht31read = &B10001001                                'Sensor address with read bit=1
Const Hirepmsb = &H24                                       'High repeatability measurement MSB
Const Hireplsb = &H00                                       'High repeatability measurement LSB
Dim Databyte(6) As Byte                                     'Data bytes to send to SHT31
Dim Readcommand(2) As Byte                                  'Array that will hold the 2 byte measurement command
Dim Tempc As Single                                         'Temperature (C) real
Dim Humidity As Single                                      'Humidity real
Dim Temp_avg As Single
Dim Hum_avg As Single
Dim S_temp As String * 6
Dim S_hum As String * 6
Readcommand(1) = Hirepmsb                                   'SHT measurement command single shot, high repeatability, clock stretching disabled
Readcommand(2) = Hireplsb
Dim Sht_read_cntr As Byte
Dim Averaging As Byte : Averaging = 2

'ADC
Dim U As Word
Dim Voltage As Single
Dim S_voltage As String * 4

'UART
Dim Ir As Byte
Dim Print_msg As Bit

'Timer
Dim Sekunda As Word
Dim Led_timer As Byte

'Nastavitve
Dim Id As Byte                                              'ID slave enote
Dim E_id As Eram Byte
Dim Level As Byte                                           '0-9, 0=izklop
Dim E_level As Eram Byte
Dim Duration As Byte                                        '10-180 s pihanja v x smer
Dim E_duration As Eram Byte
Dim Target_hum As Word
Dim E_target_hum As Eram Word

'Motor
Dim Motor_enable As Bit
Dim Direction As Bit                                        '0=noter, 1=ven
Dim Direct_control As Bit                                   '1-direktno krmiljenje PWM z master enote, ,0-samostojno delovanje

'-------------------------------------------------------------------------------

'Inicializacija I2C vmensika
Config Scl = Portc.5                                        'I2C pini
Config Sda = Portc.4
I2cinit

'Vklop HM-TRP RF modula
Reset Rf_en                                                 '0=enabled
Set Rf_cfg                                                  'normal mode

'LED vklopna sekvenca
Set Led_r : Waitms 500 : Reset Led_r
Set Led_b : Waitms 500 : Reset Led_b
Set Led_g : Waitms 500 : Reset Led_g
Enable Interrupts

'Branje EEPROMa
Level = E_level
   If Level > 250 Then Level = 30 : E_level = Level

Duration = E_duration
   If Duration > 180 Then Duration = 60 : E_duration = Duration

Target_hum = E_target_hum
   If Target_hum > 80 Then Target_hum = 50 : E_target_hum = Target_hum

Id = E_id
   If Id > 250 Then Id = 1 : E_id = Id

Print "Device startup!"
Print "Version:" ; Version(2)
Print "Set humidity: " ; Target_hum ; " %"
Print "Set interval: " ; Duration ; " s"
Print "Set power: " ; Level ; " (1-125)";
Print Chr(027);                                             'Da pobrie buffer

Motor_enable = 1                                            'Default vklopljen

Main:

Do
   Gosub Read_sht31
   Gosub Set_motor

   If Print_msg = 1 Then Gosub Print_data

   If Led_timer > 5 Then
      If Motor_enable = 1 Then Set Led_g : Set Led_r
      If Motor_enable = 0 Then Set Led_g
      Waitms 50
      Led_timer = 0
   End If

   Reset Led_b
   Reset Led_g
   Reset Led_r
Loop









'-------------------------------------------------------------------------------
Print_data:
   Print "REC-" ; Id ; " T:" ; S_temp ; " H:" ; S_hum ; " PWR:" ; Pwm0a ; "/" ;
      If Pwm0a > 127 Then Print "in";
      If Pwm0a < 127 Then Print "out" ;
      If Pwm0a = 127 Then Print "---";
      Print "/EN:" ; Motor_enable ;
      Print " t:" ; Sekunda ; " DC:" ; Direct_control
      Print Chr(027);
   Print_msg = 0
Return


Set_motor:
   If Direct_control = 0 Then
      If Motor_enable = 0 Then
         Pwm0a = 127                                        'Srednja pozicija - motor stoji
      Elseif Motor_enable = 1 Then
         If Sekunda < Duration Then
            If Direction = 0 Then                              'noter
               Pwm0a = 127 - Level
            Elseif Direction = 1 Then                          'ven
               Pwm0a = 127 + Level
            End If
         Elseif Sekunda > Duration Then
            Toggle Direction
            Set Led_b : Set Led_r : Waitms 250 : Reset Led_b : Reset Led_r
            Sekunda = 0
         End If
      End If
   Elseif Direct_control = 1 Then
      Pwm0a = Level
   End If
Return



Read_sht31:
     Incr Sht_read_cntr
     I2csend Sht31write , Readcommand(1) , 3
     Waitms 30                                              'Wait for measurement
   'Get 6 bytes of data from the SHT31
     I2creceive Sht31read , Databyte(1) , 1 , 6
   'Calculate temperatures
     Tempc = 256 * Databyte(1)                              'MSB *256
     Tempc = Tempc + Databyte(2)                            '+LSB = Datasheet ST
     Tempc = 175. * Tempc                                   'Temperature calculation per data sheet
     Tempc = Tempc / 65535.                                 'Temperature calculation continued
     Tempc = Tempc - 45.                                    'Calculated temperature in C
     Temp_avg = Temp_avg + Tempc
   'Calculate humidity
     Humidity = 256 * Databyte(4)                           'MSB*256
     Humidity = Humidity + Databyte(5)                      '+LSB = Datasheet SRH
     Humidity = 100. * Humidity                             'Humidity calculation per data sheet
     Humidity = Humidity / 65535                            'Calculated humidity
     Hum_avg = Hum_avg + Humidity

     If Sht_read_cntr = Averaging Then                      'Povpreenje meritev
         Temp_avg = Temp_avg / Averaging
         Hum_avg = Hum_avg / Averaging
         S_temp = Fusing(temp_avg , "##.#")
         S_hum = Fusing(hum_avg , "##.#")
         Sht_read_cntr = 0
         Temp_avg = 0
         Hum_avg = 0
     End If
Return


Read_adc:
   U = Getadc(7)
   Voltage = U / 55.5
   S_voltage = Fusing(voltage , "##.##")
Return



Serial0charmatch:
   Pushall

'   If _rs232inbuf0(_rs_bufcountr0 - 1) = 13 Then
'      Uart_len = _rs_bufcountr0 - 1
'      Uart_len = _rs_bufcountr0 - 2
'   For Ir = 1 To Uart_len                                   'Input Uart1_str , Noecho
'      Uart_arr(ir) = _rs232inbuf0(ir)
'   Next
'      Uart_rx_ok = 1

      If _rs232inbuf0(_rs_bufcountr0 - 4) = Id Then

         If _rs232inbuf0(_rs_bufcountr0 - 3) = 0 Then       'Stop motor
            Motor_enable = 0
            Pwm0a = 127
            Direct_control = 0
            Print "MOTOR STOP"

         Elseif _rs232inbuf0(_rs_bufcountr0 - 3) = 1 Then   'Run motor
            Motor_enable = 1
            Direct_control = 0
            Print "MOTOR ENABLE"

         Elseif _rs232inbuf0(_rs_bufcountr0 - 3) = 2 Then   'Print data
            Gosub Print_data

         Elseif _rs232inbuf0(_rs_bufcountr0 - 3) = 3 Then   'Print data
            Sekunda = 0
            Direct_control = 0
            Print "Timer reset!"

         Elseif _rs232inbuf0(_rs_bufcountr0 - 3) = 9 Then   'Direct controlling
            Level = _rs232inbuf0(_rs_bufcountr0 - 2)
            Direct_control = 1

         Elseif _rs232inbuf0(_rs_bufcountr0 - 3) = 10 Then  'Set target humidity 30-80%
            If _rs232inbuf0(_rs_bufcountr0 - 2) >= 30 And _rs232inbuf0(_rs_bufcountr0 - 2) <= 80 Then
               Target_hum = _rs232inbuf0(_rs_bufcountr0 - 2)
               E_target_hum = Target_hum
               Direct_control = 0
               Print "Humidity set to " ; Target_hum ; "%!"
            Else
               Print "Fail! Allowed range 30-80!"
            End If

         Elseif _rs232inbuf0(_rs_bufcountr0 - 3) = 20 Then  'Set target time 30-180s
            If _rs232inbuf0(_rs_bufcountr0 - 2) >= 30 And _rs232inbuf0(_rs_bufcountr0 - 2) <= 180 Then
               Duration = _rs232inbuf0(_rs_bufcountr0 - 2)
               E_duration = Duration
               Direct_control = 0
               Print "Time interval set to " ; Duration ; "s!"
            Else
               Print "Fail! Allowed range 30-180s!"
            End If

         Elseif _rs232inbuf0(_rs_bufcountr0 - 3) = 30 Then  'Set target motor power 1-125
            If _rs232inbuf0(_rs_bufcountr0 - 2) >= 1 And _rs232inbuf0(_rs_bufcountr0 - 2) <= 125 Then
               Level = _rs232inbuf0(_rs_bufcountr0 - 2)
               E_level = Level
               Direct_control = 0
               Print "Motor speed set to " ; Level ; "! (1-125)"
            Else
               Print "Fail! Allowed range 1-125!"
            End If

         Elseif _rs232inbuf0(_rs_bufcountr0 - 3) = 100 Then 'Set deviec ID
            If _rs232inbuf0(_rs_bufcountr0 - 2) >= 1 And _rs232inbuf0(_rs_bufcountr0 - 2) <= 250 Then
               Id = _rs232inbuf0(_rs_bufcountr0 - 2)
               E_id = Id
               Print "Device ID set to" ; Id ; "! (1-250)"
            Else
               Print "Fail! Allowed range 1-250!"
            End If
         End If
         Set Led_b
      Else
         Set Led_r
      End If

      Clear Serialin
   Popall
Return



Timer1_1s:
   Load Timer1 , Timer1reload
   Incr Sekunda
   Incr Led_timer
'   Print_msg = 1
Return